/*****************************************************************************
 *
 *  AngleListParameter.cc                       XMM Science Analysis Subsystem
 *
 *  Angle-list task parameter
 *
 *  (c) 1999  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: AngleListParameter.cc,v 1.4 2001/03/28 19:20:34 jbakker Exp $
 *
 *****************************************************************************/

#include "AngleListParameter.h"
#include "Xmm.h"

#include <iostream>


//================================================================
//  Class AngleListParameter
//================================================================

/*** Constructor ***/

AngleListParameter::AngleListParameter()
{
    _mode = AngleFormatter::Degrees;
}


/*** Set the format mode ***/

void AngleListParameter::setMode(AngleFormatter::AngleMode mode)
{
    _mode = mode;
    notifyView();
}


/*** Format a single element as a string ***/

string AngleListParameter::doubleAsString(double value) const
{
    AngleFormatter t(_mode);

    return "\"" + t.asString(value) + "\"";
}


/*** Parse a single list element ***/

bool AngleListParameter::parseDouble(const string& s, double& result, bool first)
{
    AngleFormatter t;
    bool ok = t.parse(s, result);

    if(ok && first)                // Base mode on first element
        _mode = t.mode();

    return ok;
}
