//
// Simple test harness for the C bindings to the parameter interface.
//
// TODO:
//   - test failure/success
//   - set parameters
//   - list parameters
//
// Giuseppe Vacanti -- March 30, 1999
//
#include <Parameter.h>
#include <param.h>
#include <paramc.h>

#include <errstr.h>

int main(int argc, char* argv[])
{

    string taskname(argv[0]);
    errHandler.name(taskname);

    openParameters(taskname);
    gParameters->parseCommandLine(argc,argv);

    // single parameters
    cout << "---> single parameters <---" << endl;

    cout << "ival = " << int_parameter("ival", -1) << endl;
    assert(int_parameter("ival", -1) == 42);

    cout << "rval = " << real_parameter("rval", -1) << endl;
    assert(real_parameter("rval", -1) == 1.23e-5);

    cout << "sval = " << string_parameter("sval", -1) << endl;
    assert(strcmp(string_parameter("sval", -1),"ab #,cd") == 0);

    cout << "bval0 = " << boolean_parameter("bval0", -1) << endl;
    assert(boolean_parameter("bval0", -1) == false);

    cout << "bval1 = " << boolean_parameter("bval1", -1) << endl;
    assert(boolean_parameter("bval1", -1) == true);

    cout << "fval = " << string_parameter("fval", -1) << endl;
    assert(strcmp(string_parameter("fval", -1), "temp") == 0);

    cout << "set = " << string_parameter("set", -1) << endl;
    assert(strcmp(string_parameter("set", -1), "temp") == 0);

    // list parameters
    cout << "---> list parameters <---" << endl;

    cout << "blist -> " << parameter_count("blist") << endl;
    for (int i = 0; i < parameter_count("blist");)
      cout << boolean_parameter("blist", i++) << endl;

    cout << "ilist -> " << parameter_count("ilist") << endl;
    for (int i = 0; i < parameter_count("ilist");)
      cout << int_parameter("ilist", i++) << endl;

    cout << "rlist -> " << parameter_count("rlist") << endl;
    for (int i = 0; i < parameter_count("rlist");)
      cout << real_parameter("rlist", i++) << endl;

    cout << "slist -> " << parameter_count("slist") << endl;
    for (int i = 0; i < parameter_count("slist");)
      cout << string_parameter("slist", i++) << endl;

    cout << "clist -> " << parameter_count("clist") << endl;
    for (int i = 0; i < parameter_count("clist");)
      cout << string_parameter("clist", i++) << endl;

    cout << "flist -> " << parameter_count("flist") << endl;
    for (int i = 0; i < parameter_count("flist");)
      cout << string_parameter("flist", i++) << endl;

    cout << "setlist -> " << parameter_count("setlist") << endl;
    for (int i = 0; i < parameter_count("setlist");)
      cout << string_parameter("setlist", i++) << endl;


}

  
