/****************************************************************************
 *
 *  testparampcs.cc                            XMM Science Analysis Subsystem
 *
 *  Test PCS mode of command-line
 *
 *  (c) 1998  ESA  -  
 *
 *  $Id: testparampcs.cc,v 1.5 2001/11/19 11:50:30 jbakker Exp $
 *
 *****************************************************************************/

#include <Parameter.h>
#include <param.h>
#include <iostream>

int main(int argc, char* argv[])
{
    openParameters("testparampcs");
    gParameters->parseCommandLine(argc,argv);
    
    cout << endl << "Parameter info:" << endl 
	 << *gParameters << endl;

    string sp = stringParameter("sp");
    cout << "sp   = " << sp << endl;
    assert(sp == "res1");

    int nodf = parameterCount("odf");
    assert(nodf == 2);
    for(int i=0; i<nodf; i++)
      cout << "odf[" << i << "] = \"" 
	   << stringParameter("odf",i) << '"' << endl;
    assert(stringParameter("odf",0) == "odf1");
    assert(stringParameter("odf",1) == "odf2");

    int ncoeff = parameterCount("coeff");
    assert(ncoeff == 3);
    for(int i=0; i<ncoeff; i++)
      cout << "coeff[" << i << "] = \"" 
	   << stringParameter("coeff",i) << '"' << endl;
    assert(stringParameter("coeff",0) == "co1");
    assert(stringParameter("coeff",1) == "co2");
    assert(stringParameter("coeff",2) == "co3");

    int nccf = parameterCount("ccf");
    assert(nccf == 2);
    for(int i=0; i<nccf; i++)
      cout << "ccf[" << i << "] = \"" 
	   << stringParameter("ccf",i) << '"' << endl;
    assert(stringParameter("ccf",0) == "ccf1");
    assert(stringParameter("ccf",1) == "ccf2");

    closeParameters();
}
